#-*-coding:utf-8-*- 
import sqlite3    
import checks
import random
import tkinter.messagebox as tkMessageBox
import tkinter
import tkinter.font as tkFont
import readconf
import os
import tkinter.filedialog as tkFileDialog
def importWords():#导入词库
    url = tkFileDialog.askopenfilename(title = '打开要翻译的词库文件',      #创建打开文件对话框
                filetypes=[('数据库文件', '*.db')] ) #指定文件类型
    conn=sqlite3.connect(url)
    curs=conn.cursor()             
    curs.execute("select * from words")
    ls=curs.fetchall()
    conn.commit()
    conn.close()
    wordls=ls[:]
    inputls=[]
    for i in range(0,len(wordls)):
        inputls.append(wordls[i][1]+"#"+wordls[i][2])   
    ans=tkMessageBox.askokcancel("消息", "导入包含上千单词的词库可能需要几分钟的时间，请耐心等待……点击'OK'开始导入……")
    if ans==True:
        for i in inputls:
            insertData(i)       
        tkMessageBox.showinfo("消息","词库导入成功！")
    
def chanWord(top,id,wd,exp):#修改单词子函数
    charry=[' ',';',',','，','；']#分割字符数组
    for ich in charry:
        wd=wd.replace(ich,'@')
        exp=exp.replace(ich,'@')    
    if len(id)==0:
        tkMessageBox.showinfo("错误","请填写要修改的单词的id！")
        return
    checks.changeWords(id,wd,exp)
    top.destroy()
def changeWords():#修改单词
    top=tkinter.Tk()
    top.title("修改单词信息")
    top.resizable(0,0)
    ft=tkFont.Font(top,family='Monospace',weight=tkFont.BOLD,size=16)#字体   
    lbl1=tkinter.Label(top,text="编号( id ):",font=ft)
    lbl1.grid(row=0,column=0,padx=20,pady=10)
    inp1=tkinter.Entry(top,font=ft,width=50)
    inp1.grid(row=0,column=1,padx=20,pady=10)
    lbl2=tkinter.Label(top,text="单词(word):",font=ft)
    lbl2.grid(row=1,column=0,padx=20,pady=10)
    inp2=tkinter.Entry(top,font=ft,width=50)
    inp2.grid(row=1,column=1,padx=20,pady=10)
    lbl3=tkinter.Label(top,text="解释(expl):",font=ft)
    lbl3.grid(row=2,column=0,padx=20,pady=10) 
    inp3=tkinter.Entry(top,font=ft,width=50)
    inp3.grid(row=2,column=1,padx=20,pady=10)
    btn1=tkinter.Button(top,text="提交",font=ft,width=10,command=lambda:chanWord(top,inp1.get().strip(),inp2.get().strip(),inp3.get().strip()))
    btn1.grid(row=3,columnspan=2,padx=10,pady=10)
    top.mainloop()
    
def getRecent():#得到所有单词
    ls=checks.getRecent()
    top=tkinter.Tk()
    top.title("查看所有单词")
    top.resizable(0,0)
    ft=tkFont.Font(top,family='Monospace',weight=tkFont.BOLD,size=16)#字体
    lbox=tkinter.Listbox(top,height=20,width=80,font=ft)
    scrollbar1=tkinter.Scrollbar(top,command=lbox.yview,width=20)
    scrollbar2=tkinter.Scrollbar(top,orient=tkinter.HORIZONTAL,command=lbox.xview,width=20)
    lbox.configure(xscrollcommand=scrollbar2.set,yscrollcommand=scrollbar1.set)
    scrollbar1.pack(side=tkinter.RIGHT,fill=tkinter.Y)
    scrollbar2.pack(side=tkinter.BOTTOM,fill=tkinter.X)
    lbox.pack()
    lbox.insert(tkinter.END,"编号(id) 单词(word) 解释(expl) 计数(count)")
    for i in range(0,len(ls)):
        lbox.insert(tkinter.END,ls[i])    
    top.mainloop()    
def chLimit(txt,top):#修改下限功能函数
    if len(txt.get())!=0:
        newlimit=int(txt.get())
        readconf.writeConf('LimitCount',newlimit)
    top.destroy()
def changeLimit():#修改下限
    top=tkinter.Tk()
    top.title("修改下限")
    ft=tkFont.Font(top,family='Monospace',weight=tkFont.BOLD,size=16)#字体
    lbl1=tkinter.Label(top,text="请输入新的下限：",font=ft)
    lbl1.grid(row=0,column=0,padx=20)
    txt1=tkinter.Entry(top,font=ft)
    txt1.grid(row=0,column=1,padx=20)
    btn1=tkinter.Button(top,text="确定",font=ft,command=lambda:chLimit(txt1,top))
    btn1.grid(row=0,column=2,padx=20)
    top.mainloop()
    
def getSimilarWord(txtin):#单词提示
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()    
    sql="select * from words where word like '"+txtin+"%' order by word"
    curs.execute(sql)
    ls=curs.fetchall()    
    conn.commit()
    if len(ls)!=0:
        return str(ls[0][1])
    else:
        return ""
    
    
def getError():#读取错误信息
    ls=[]
    if os.path.exists("wrongwords.txt"):
        fp=open("wrongwords.txt","r")
        ls=fp.readlines()
        return ls[:]
    else:
        tkMessageBox.showinfo("消息","目前没有错误信息！")
        
    
def insertNote(wd):#临时记录错误单词
    fp=open("wrongwords.txt","a")
    wd=wd+"\n"
    fp.writelines(wd)
    fp.close()
def exportWords():#导出词库
    writestr=""
    conn=sqlite3.connect('words.db')
    curs=conn.cursor()    
    sql="select word,expl from words order by word"
    curs.execute(sql)
    ls=curs.fetchall()
    for i in ls:
        wd=i[0]
        exp=i[1]
        wd=wd.replace('@',' ')
        exp=exp.replace('@',' ')
        writestr=writestr+wd+'#'+exp+"\r\n"
    writestr=writestr+"\n"
    conn.commit()
    conn.close()    
    fp=open('ExportWords.txt','w')
    fp.writelines(writestr)
    fp.close()
    tkMessageBox.showinfo("消息","数据库中的单词已经全部导出到当前程序目录的ExportWords.txt文本文件中！")
def getPassNumber():#统计已通过测试的词汇
    return (checks.getPassNumber(checks.getMaxCount()),checks.getDBLength())
def checkTrue(wd,exp,paramDict):#检查选择是否正确
    if paramDict['ShowWords']=='1':
        rightAns=checks.getExp(wd)[0]
        exp=exp.split()[1]
        exp=exp.split(',')
        for i in range(0,len(exp)):
            if exp[i] not in rightAns:
                checks.subCount(wd)
                insertNote(wd)
                tkMessageBox.showinfo("消息","很遗憾，答错了！")   
                return
        checks.addCount(wd)
        tkMessageBox.showinfo("消息","恭喜你，答对了！")
    elif paramDict['ShowWords']=='0':
        rightAns=checks.getWord(wd)[0]
        exp=exp.split()[1]
        exp=exp.split(',')
        for i in range(0,len(exp)):
            if exp[i] not in rightAns:
                checks.subCount(rightAns)
                insertNote(rightAns)
                tkMessageBox.showinfo("消息","很遗憾，答错了！")   
                return               
        checks.addCount(rightAns)
        tkMessageBox.showinfo("消息","恭喜你，答对了！")
             
def getWords(exp):#随机显示单词
    returnlist=[]
    length=checks.getDBLength()
    if length==None:
        tkMessageBox.showinfo("消息","数据库中无单词，请先录入单词！")
        return 0
    else:
        #先选出正确答案
        rightAns=checks.getWord(exp)[0]
        rightId=checks.getWord(exp)[1]
        #产生其他三个随机答案
        number=0
        conn=sqlite3.connect('words.db')
        curs=conn.cursor()      
        while 1:
            random.seed()
            i=random.randint(1,length)
            if i!=rightId:
                sql="select * from words where id="+str(i)
                curs.execute(sql)
                ls=curs.fetchall()    
                if len(ls)!=0:
                    returnlist.append(ls[0][1])
                    number=number+1                
            if number==3:
                break
        conn.commit()
        conn.close()
        #随机插入正确答案
        random.seed()
        posi=random.randint(0,3)
        returnlist.insert(posi,rightAns)
    return returnlist    
def getExpls(wd):#随机显示解释
    returnlist=[]
    length=checks.getDBLength()
    if length==None:
        tkMessageBox.showinfo("消息","数据库中无单词，请先录入单词！")
        return 0
    else:
        #先选出正确答案
        rightAns=checks.getExp(wd)[0]
        rightAns=rightAns.split('@')
        if '' in rightAns:
            rightAns.remove('')
        rightAnsStr=""
        random.seed()
        aimpo=random.randint(1,5)
        for ps in range(0,len(rightAns)):
            rightAnsStr=rightAnsStr+rightAns[ps]+","
            if ps==aimpo:
                break
        rightAnsStr=rightAnsStr[:-1]
        rightId=checks.getExp(wd)[1]
        #产生其他三个随机答案
        number=0
        conn=sqlite3.connect('words.db')
        curs=conn.cursor()      
        while 1:
            random.seed()
            i=random.randint(1,length)
            if i!=rightId:
                sql="select * from words where id="+str(i)
                curs.execute(sql)
                ls=curs.fetchall()    
                if len(ls)!=0:
                    exptemp=ls[0][2].split('@')
                    if '' in exptemp:
                        exptemp.remove('')
                    random.seed()
                    numb=random.randint(1,5)
                    retls=[]
                    for ii in range(0,numb):
                        random.seed()
                        retls.append(random.randint(0,len(exptemp)-1))
                    listtemp=[]
                    for jj in range(0,len(retls)):
                        listtemp.append(exptemp[retls[jj]])
                    listtemp=list(set(listtemp))
                    listtempstr=""
                    for k in listtemp:
                        listtempstr=listtempstr+k+","
                    listtempstr=listtempstr[:-1]
                    returnlist.append(listtempstr)
                    number=number+1                
            if number==3:
                break
        conn.commit()
        conn.close()
        #随机插入正确答案
        random.seed()
        posi=random.randint(0,3)
        returnlist.insert(posi,rightAnsStr)
    return returnlist
def getExpl():#显示测试的解释
    strwd="待测目标"
    length=checks.getDBLength()
    if length==None:
        tkMessageBox.showinfo("消息","数据库中无单词，请先录入单词！")
        return strwd
    else:
        while 1:
            random.seed()
            i=random.randint(1,length)
            conn=sqlite3.connect('words.db')
            curs=conn.cursor()        
            curs.execute("select * from words where id="+str(i))
            ls=curs.fetchall()          
            conn.commit()
            conn.close()    
            strwd=ls[0][2]
            strwd1=strwd.split('@')
            if '' in strwd1:
                strwd1.remove('')
            strwdStr=""
            random.seed()
            aimpo=random.randint(1,5)
            for ps in range(0,len(strwd1)):
                strwdStr=strwdStr+strwd1[ps]+","
                if ps==aimpo:
                    break
            strwdStr=strwdStr[:-1]     
            error=checks.checkError()#检查是不是所有的count都越界，是返回1
            if error==1:
                tkMessageBox.showinfo("消息","单词都已通过测试，请输入新的单词！")
                strwd="待测目标"
                return strwd
            flag=checks.checkCountExp(strwd)#检查count是不是大于10,是返回1
            if flag==0:
                return strwdStr
        
def getWord():#显示测试的词汇
    strwd="待测目标"
    length=checks.getDBLength()
    if length==None:
        tkMessageBox.showinfo("消息","数据库中无单词，请先录入单词！")
        return strwd
    else:
        while 1:
            random.seed()
            i=random.randint(1,length)
            conn=sqlite3.connect('words.db')
            curs=conn.cursor()        
            curs.execute("select * from words where id="+str(i))
            ls=curs.fetchall()          
            conn.commit()
            conn.close()    
            strwd=ls[0][1]
            error=checks.checkError()#检查是不是所有的count都越界，是返回1
            if error==1:
                tkMessageBox.showinfo("消息","单词都已通过测试，请输入新的单词！")
                strwd="待测目标"
                return strwd
            flag=checks.checkCount(strwd)#检查count是不是大于10,是返回1
            if flag==0:
                return strwd
        
def insertData(word):#word的格式为  abandon#抛弃，遗弃，放弃
    if '#' in word:#英文井号
        wd=word.split('#')[0]
        exp=word.split('#')[1]
    elif '＃' in word:#中文井号
        wd=word.split('＃')[0]
        exp=word.split('＃')[1]
    else:#忽略非法行
        return
    wd=wd.strip()
    exp=exp.strip()
    charry=[' ',';',',','，','；']#分割字符数组
    for ich in charry:
        wd=wd.replace(ich,'@')
        exp=exp.replace(ich,'@')
    if len(wd)==0:#忽略空行
        return    
    flag=checks.existWord(wd)#存在返回1，不存在返回0
    if flag==0:
        conn=sqlite3.connect('words.db')
        curs=conn.cursor()
        sql="insert into words ('word','expl','count') values ('"+wd+"','"+exp+"',0)"#默认计数为0
        curs.execute(sql)
        conn.commit()
        conn.close()
    elif flag==1:
        conn=sqlite3.connect('words.db')
        curs=conn.cursor()
        curs.execute("select * from words where word='"+wd+"'")
        ls=curs.fetchall()
        conn.commit()                
        #ls[0][2]
        expla=ls[0][2]
        expls=exp.split('@')
        for i in expls:
            if i not in expla:
                expla=expla+'@'+i
        #print(expl)
        curs.execute("update words set expl='"+expla+"' where word='"+wd+"'")
        conn.commit()
        conn.close()
    
    
